<?php
// Code to add current weather to post at time of publish
class WeatherIconPost
{

	// Add weather on publish
	function add_weather($id)
	{
		global $WI;
		
		if (in_array('show_current_weather_at_post', $WI->settings['display_options']))
		{
			delete_post_meta($id, '_metar');
			delete_post_meta($id, '_location');

			$location = $WI->settings['locations'][$WI->settings['default_location']];
		
			// Retrieve current weather conditions for default station/location
			$metar = $WI->get_metar($location['station'], $location['latitude'], $location['longitude'], $location['gmt_offset'], $location['dst'], '', '');
			
			// Ensure we have a metar before adding it
			if (strpos($metar->http_response, '200 '))
			{
				add_post_meta($id, '_metar', $metar->raw_metar);
				add_post_meta($id, '_location', $WI->settings['default_location']);
			}
		}
	}

	// Display Weather if contained in metar data, and current_weather_on_post is true
	function display_weather($output)
	{
		global $WI;

		if (in_array('show_current_weather_at_post', $WI->settings['display_options']))
		{
			$values	= get_post_custom_values('_metar');
			$raw_metar = $values[0];

			$values	= get_post_custom_values('_location');
			$location = $WI->settings['locations'][$values[0]];

			if (!empty($raw_metar) && !empty($location))
			{
				$metar = new WeatherIconMetar($raw_metar, $location['latitude'], $location['longitude'], $location['gmt_offset'], $location['dst'], '<li>', '</li>');
				
				$output .= '<div class="weather-meta"><p>Weather at post time:</p><ul>';
				$output .= $metar->get_temp();
				$output .= $metar->get_wind();
				$output .= $metar->get_visibility();
				$output .= $metar->get_conditions();
				$output .= "</ul></div>";
			}
		}

		return $output;
	}

}

add_action('publish_post', array('WeatherIconPost', 'add_weather'));
add_action('the_content', array('WeatherIconPost', 'display_weather'));

?>
