<?php

# This file allows you to use WeatherIcon with the kickass Sidebar Widgets plugin [ http://automattic.com/code/widgets/ ]
# Yay for no more template editing! :)

function weathericon_sidebarwidget_init() {
	if (!function_exists('register_sidebar_widget')) return;

	function widget_weathericon_getoptions($number)
	{
		$options = get_settings('weathericon_sidebarwidget');

		if (!is_array($options[$number]))
		{
			$options[$number] = array(
				'title' =>	__('My Weather', 'WI'),
			);
		}

		return $options;
	}

	function widget_weathericon($args, $number = 1)
	{
		extract($args);

		$options = widget_weathericon_getoptions($number);
		$options = $options[$number];

		$title = $options['title'];
		if (empty($title)) $title = '&nbsp;';

		echo $before_widget . $before_title . $title . $after_title . "<ul class='weathericonwidget'>\n";
		WeatherIcon('location=' . $options['location'] . "&before=<li>&after=</li>\n");
		echo "</ul>\n" . $after_widget;
	}

	function widget_weathericon_control($number)
	{
		global $WI;

		$options = $newoptions = widget_weathericon_getoptions($number);

		if ($_POST["weathericon-submit-$number"]) {
			$newoptions[$number]['title'] = strip_tags(stripslashes($_POST["weathericon-title-$number"]));
			$newoptions[$number]['location'] = stripslashes($_POST["weathericon-location-$number"]);
		}
		if ($options !== $newoptions) {
			$options = $newoptions;
			update_option('weathericon_sidebarwidget', $options);
		}

		$title = htmlspecialchars($options[$number]['title'], ENT_QUOTES);

		echo '				<p><label for="weathericon-title-' . $number . '">' . __('Title:', 'WI') . ' <input style="width: 250px;" id="weathericon-title-' . $number . '" name="weathericon-title-' . $number . '" type="text" value="' . $options[$number]['title'] . '" /></label></p>' . "\n";

		echo "				<p>\n";
		echo '					<label for="weathericon-location-' . $number . '">' . __('Preset Location:', 'WI') . " \n";
		echo '					<select name="weathericon-location-' . $number . '">' . "\n";
		foreach ($WI->settings['locations'] as $loc_name => $loc_info)
		{
			echo '						<option value="' . htmlspecialchars($loc_name, ENT_QUOTES) . '"';
			
			if (($options[$number]['location'] == $loc_name) || (!isset($options[$number]['location']) && $WI->settings['default_location'] == $loc_name))
			{
				echo ' selected="selected"';
			}

			echo '>' . htmlspecialchars($loc_name, ENT_QUOTES) . "</option>\n";
		}
		echo "					</select>\n";
		echo "					</label>\n";
		echo "				<p>\n";
		echo '				<input type="hidden" id="weathericon-submit-' . $number. '" name="weathericon-submit-' . $number. '" value="1" />' . "\n";
	}

	function widget_weathericon_setup()
	{
		$options = $newoptions = get_option('weathericon_sidebarwidget');
		if (isset($_POST['weathericon-number-submit'])) {
			$number = (int) $_POST['weathericon-number'];
			if ( $number > 9 ) $number = 9;
			if ( $number < 1 ) $number = 1;
			$newoptions['number'] = $number;
		}
		if ($options != $newoptions) {
			$options = $newoptions;
			update_option('weathericon_sidebarwidget', $options);
			widget_weathericon_register($options['number']);
		}
	}

	function widget_weathericon_page()
	{
		$options = get_option('weathericon_sidebarwidget');

		?>
	<div class="wrap">
		<form method="POST">
			<h2><?php _e('WeatherIcon Widgets', 'WI'); ?></h2>
			<p style="line-height: 30px;"><?php _e('How many WeatherIcon widgets would you like?', 'WI'); ?>
			<select id="weathericon-number" name="weathericon-number" value="<?php echo $options['number']; ?>">
<?php for ( $i = 1; $i < 10; ++$i ) echo "				<option value='$i' ".($options['number']==$i ? "selected='selected'" : '').">$i</option>"; ?>
			</select>
			<span class="submit"><input type="submit" name="weathericon-number-submit" id="weathericon-number-submit" value="<?php _e('Save'); // No need for 'WI' here ?>" /></span></p>
		</form>
	</div>
<?php
	}

	function widget_weathericon_register()
	{
		$options = get_option('weathericon_sidebarwidget');
		$number = $options['number'];
		if ( $number < 1 ) $number = 1;
		if ( $number > 9 ) $number = 9;
		for ($i = 1; $i <= 9; $i++) {
			$name = array('WeatherIcon %s', null, $i);
			register_sidebar_widget($name, $i <= $number ? 'widget_weathericon' : /* unregister */ '', $i);
			register_widget_control($name, $i <= $number ? 'widget_weathericon_control' : /* unregister */ '', 300, 90, $i);
		}
		add_action('sidebar_admin_setup', 'widget_weathericon_setup');
		add_action('sidebar_admin_page', 'widget_weathericon_page');
	}
	widget_weathericon_register();
}

add_action('plugins_loaded', 'weathericon_sidebarwidget_init');

?>
