<?php

# This file creates a weather widget for the dashboard replacement, WP-Dash [ http://somethingunpredictable.com/wp-dash/ ]
# It's not a class because as far as I know, WP-Dash can't have widget functions within a class (correct me if I'm wrong) -Viper

// This gives the widget to WP-Dash
function weathericon_wpdash_available()
{
	if (function_exists('make_widget_available'))
	{
		make_widget_available(__('WeatherIcon', 'WI'), __('Displays current weather for specified location.', 'WI'), 'weathericon_wpdash_', 'weathericon_wpdash_configure', 'configurable=true;spawn_multiple=true;');
	}
}
add_action('init', 'weathericon_wpdash_available');


// This is the main content of the weather
function weathericon_wpdash_content($ID)
{
	$options = get_option("weathericon_wpdashwidget$ID");

	return WeatherIcon('location=' . $options['location'] . '&before=&after=<br />&debug=FALSE&display=FALSE');
}


// This is the function that creates the configuration view
function weathericon_wpdash_configure($ID)
{
	global $WI, $wpdb, $widgettable;

	$options = get_option("weathericon_wpdashwidget$ID");
	$widget_title = $wpdb->get_var("SELECT name FROM $widgettable WHERE ID='$ID'");

	// If the current title is "WeatherIcon", clear it out
	if ($widget_title === __('WeatherIcon', 'WI'))
	{
		unset($widget_title);
	}

	$output = '<div id="weatherconfig' . $ID . '">
	<form name="weatherconfig' . $ID . '" method="post">
		<input type="hidden" name="configweathericon" value="'. $ID .'" />
		<label for="weather_location">' . __('Location:', 'WI') . '
			<select name="weather_location">
';
	
	foreach ($WI->settings['locations'] as $loc_name => $loc_info)
	{
		$output .= '				<option value="' . htmlspecialchars($loc_name, ENT_QUOTES) . '"';
		
		if (($options['location'] == $loc_name) || (!isset($options['location']) && $WI->settings['default_location'] == $loc_name))
		{
			$output .= ' selected="selected"';
		}

		$output .= '>' . htmlspecialchars($loc_name, ENT_QUOTES) . "</option>\n";
	}

	$output .= '			</select>
		</label><br />
		<br />' . sprintf(__('<a href="%s" title="Click here to visit the main options page and add a new preset location">Add a new location &raquo;</a>', 'WI'), 'options-general.php?page=WeatherIconConfig.php#PresetLocations') . '<br />
		<br />
		' . __('Widget Title:', 'WI') . '&nbsp;<input type="text" name="widget_title" value="' . $widget_title . '" /><br />
		<input type="submit" name="save_weather_settings" value="' . __('Save Settings', 'WI') . '" style="margin-top: 15px; width: auto;" />
	</form>
</div>
';

	return $output;
}

// Handle submissions of the widget configuration
if (isset($_POST['configweathericon']))
{
	add_action('init', 'weathericon_wpdash_updateconfig', 5);
}
function weathericon_wpdash_updateconfig()
{
	global $wpdb, $widgettable;

	$options = get_option('weathericon_wpdashwidget' . $_POST['configweathericon']);

	// Grab the title input value or if it's blank, set it to the selected location
	$widget_title = ($_POST['widget_title']) ? $_POST['widget_title'] : $_POST['weather_location'];

	// If the current widget title is the same as the old location, change the title to the new location
	if ($widget_title == $options['location'])
	{
		$widget_title = $_POST['weather_location'];
	}

	update_option('weathericon_wpdashwidget' . $_POST['configweathericon'], array('location' => $_POST['weather_location']));

	$wpdb->hide_errors();
	$wpdb->query("UPDATE $widgettable SET name='" . $widget_title . "' WHERE ID='" . $_POST['configweathericon'] . "'");
}


// On deactivation of a widget, clean up it's options
function weathericon_wpdash_deactivate($ID)
{
	delete_option("weathericon_wpdashwidget$ID");
}


// And a bit of CSS to control the widget
function weathericon_wpdash_css($ID) {
	return default_widget_css($ID) . "
		#widget$ID {
			width: 220px;
		}
		#content$ID {
			width: 219px;
			overflow: auto;
			text-align: center;
			padding-bottom: 2px;
		}
		#weatherconfig$ID input, #weatherconfig$ID select {
			font-size: 100%;
		}
		#weatherconfig$ID input {
			text-align: center;
		}
		";
}

?>
